//#include <stdio.h>

#include "HtmlDocument.h"


namespace Cgi
{


HtmlDocument::HtmlDocument(doctype_t t)
:ElementList("html")
,m_doctype(t)
{
}


HtmlDocument::~HtmlDocument()
{
}


std::string HtmlDocument::ToString() const
{
	std::string r;
	switch (m_doctype)
	{
	case DOCTYPE_HTML_20:
		r = "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">";
		break;
	case DOCTYPE_HTML_32:
		r = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">";
		break;
	case DOCTYPE_HTML_401_TRANSITIONAL:
		r = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
		break;
	case DOCTYPE_HTML_401_STRICT:
		r = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">";
		break;
	case DOCTYPE_HTML_401_FRAMESET:
		r = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\" \"http://www.w3.org/TR/html4/frameset.dtd\">";
		break;
	case DOCTYPE_XHTML_1_0_TRANSITIONAL:
		r = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">";
		break;
	case DOCTYPE_XHTML_1_0_STRICT:
		r = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
		break;
	case DOCTYPE_XHTML_1_0_FRAMESET:
		r = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Frameset//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd\">";
		break;
	}
	r += "\n";
	return r + ElementList::ToString();
}


} // namespace Cgi


