/*
 **	\file Link.cpp
 **	\date  2006-05-05
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "WebForm.h"
#include "Link.h"
#include "Web.h"


namespace Cgi
{


Link::Link(WebForm *p, const std::string& action, const std::string& linktext)
:Styled()
,m_webform(p)
,m_action(action)
,m_linktext(linktext)
{
}


Link::~Link()
{
	while (m_params.size())
	{
		param_v::iterator it = m_params.begin();
		Param *p = *it;
		delete p;
		m_params.erase(it);
	}
}


void Link::AddParam(const std::string& name)
{
	m_params.push_back(new Param(name));
}


void Link::AddParam(const std::string& name,const std::string& value)
{
	m_params.push_back(new Param2(name, value));
}


void Link::AddParam(const std::string& name,long value)
{
	char slask[100];
	sprintf(slask, "%ld", value);
	m_params.push_back(new Param2(name, slask));
}


const std::string& Link::GetLink()
{
	Web *web = m_webform -> GetWeb();
	char slask[1000];
	sprintf(slask, "<a");
	if (GetStyle().size())
	{
		sprintf(slask + strlen(slask), " style='%s'", GetStyle().c_str());
	}
	sprintf(slask + strlen(slask), " href='%s?%s=%s", web -> GetCgiName().c_str(),
		m_webform -> GetFormName().c_str(), m_action.c_str());
	for (param_v::iterator it = m_params.begin(); it != m_params.end(); it++)
	{
		Param *p = *it;
		strcat(slask, p -> Print().c_str());
	}
	sprintf(slask + strlen(slask), "'>%s</a>", m_linktext.c_str());
	m_link = slask;
	return m_link;
}


} // namespace Cgi


