/*
 **	\file Link.h
 **	\date  2006-05-05
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _CGI_LINK_H
#define _CGI_LINK_H

#include <string>
#include <list>
#include "Styled.h"

class WebForm;


namespace Cgi
{


class Link : public Styled
{
	class Param {
	public:
		Param(const std::string& name) : m_name(name) {}
		virtual ~Param() {}
		virtual std::string Print() {
			std::string tmp = "&amp;";
			tmp += m_name;
			return tmp;
		}
		std::string m_name;
	};
	class Param2 : public Param {
	public:
		Param2(const std::string& name,const std::string& value) : Param(name), m_value(value) {}
		std::string Print() {
			std::string tmp = "&amp;";
			tmp += m_name;
			tmp += "=";
			tmp += m_value;
			return tmp;
		}
		std::string m_value;
	};
	typedef std::list<Param *> param_v;
public:
	Link(WebForm *, const std::string& action, const std::string& linktext);
	~Link();

	void AddParam(const std::string& name);
	void AddParam(const std::string& name,const std::string& value);
	void AddParam(const std::string& name,long value);

	const std::string& GetLink();

private:
	Link(const Link& ) {} // copy constructor
	Link& operator=(const Link& ) { return *this; } // assignment operator
	WebForm *m_webform;
	std::string m_action;
	std::string m_linktext;
	param_v m_params;
	std::string m_link;
};


} // namespace Cgi


#endif // _CGI_LINK_H
