/**
 **	Parse.h - parse a string
 **
 **	Written: 1999-Feb-10 grymse@alhem.net
 **/

/*
Copyright (C) 1999  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CGI_PARSE_H
#define _CGI_PARSE_H

#include <string>


/***************************************************/
/* interface of class Parse */

//! Splits a string whatever way you want
namespace Cgi
{

class Parse
{
public:
	Parse();
	Parse(const char *);
	Parse(const char *,const char *);
	Parse(const char *,const char *,short);
	~Parse();
	short issplit(char);
	void getsplit();
	void getsplit(char *);
	std::string getword();
	void getword(char *);
	void getword(char *,int);
	void getword(char *,char *,int);
	void getrest(char *);
	long getvalue();
	void setbreak(char);
	int getwordlen();
	int getrestlen();
	void enablebreak(char);
	void disablebreak(char);
	void getline();
	void getline(char *);
	void getline(char *,int);
	int getptr();
	void EnableQuote(bool b);

private:
	Parse(const Parse& );
	Parse& operator=(const Parse& );
	char *pa_the_str;
	char *pa_splits;
	char *pa_ord;
	int   pa_the_ptr;
	char  pa_breakchar;
	char  pa_enable;
	char  pa_disable;
	short pa_nospace;
	bool  pa_quote;
};

} // namespace Cgi

#endif // _CGI_PARSE_H
