// Readhtml.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifdef _WIN32
#pragma warning(disable:4786)
#endif
#include <stdio.h>
#include <string.h>

#include "Readhtml.h"

#define DEB(x) 

namespace Cgi {

Readhtml::Readhtml(void)
{
	fn = NULL;
	fil = NULL;
	peekc = 0;
	buf = NULL;
}

Readhtml::Readhtml(char *s)
{
	Readhtml();
	fn = new char[strlen(s) + 1];
	strcpy(fn,s);
	if ((fil = fopen(s,"rt")) != NULL)
		fread(&peekc,1,1,fil);
	buf = new char[MAXL];
}

Readhtml::~Readhtml(void)
{
	if (fil)
		fclose(fil);
	if (fn)
		delete fn;
	if (buf)
		delete buf;
}

int Readhtml::getnext(char *s,int bufl)
{
	size_t i = 0;
	size_t sv = 0;

	if (!fil)
		return -1;
	if (feof(fil))
		return 0;

	if (!peekc)
		do
		{
			fread(&peekc,1,1,fil);
		} while (!feof(fil) && (peekc == 13 || peekc == 10));

// read HTML tag

	if (peekc == '<')
	{
		if (i < MAXL - 1)
			buf[i++] = peekc;
		fread(&peekc,1,1,fil);
		while (!feof(fil) && peekc != '>')
		{
			if (peekc == 13 || peekc == 10 || peekc == 9)
				peekc = 32;
			if (i < MAXL - 1)
				buf[i++] = peekc;
			fread(&peekc,1,1,fil);
		}
		if (i < MAXL - 1)
			buf[i++] = '>';
		buf[i] = 0;
		buf[bufl - 1] = 0;
		peekc = 0;
		while (buf[strlen(buf) - 1] == 32)
			buf[strlen(buf) - 1] = 0;
		strcpy(s,buf);
		// check comment
		if (!strncmp(buf, "<!--", 4))
		{
			while (!strstr(buf, "-->") && !feof(fil))
			{
				i = 0;
				fread(&peekc,1,1,fil);
				while (!feof(fil) && peekc != '>')
				{
					if (peekc == 13 || peekc == 10 || peekc == 9)
						peekc = 32;
					if (i < MAXL - 1)
						buf[i++] = peekc;
					fread(&peekc,1,1,fil);
				}
				if (i < MAXL - 1)
					buf[i++] = '>';
				buf[i] = 0;
				buf[bufl - 1] = 0;
				peekc = 0;
				while (buf[strlen(buf) - 1] == 32)
					buf[strlen(buf) - 1] = 0;
				strcat(s + strlen(s),buf);
			}
			return 3; // comment
		}
		return 1;
	}

// read string
//  0xc4-Auml, 0xc5-Aring, 0xd6-Ouml
//  0xe4-auml, 0xe5-aring, 0xf6-ouml

	if (peekc == 13 || peekc == 10 || peekc == 9)
		peekc = 32;
	if (peekc && peekc != 32)
		if (i < MAXL - 1)
			buf[i++] = peekc;
	do
	{
		fread(&peekc,1,1,fil);
		if (peekc == 13 || peekc == 10 || peekc == 9)
			peekc = 32;
	} while (peekc == 32 && !feof(fil));
	while (!feof(fil) && peekc != '<')
	{
		if (peekc == 13 || peekc == 10 || peekc == 9)
			peekc = 32;
		if (i < MAXL - 1)
			buf[i++] = peekc;
		fread(&peekc,1,1,fil);
// debug udde tecken
		if (peekc < 0)
		{
			buf[i] = 0;
			DEB(printf("%s 0x%02x\n",buf,(unsigned)peekc % 256);)
			sv++;
		}
	}
	buf[i] = 0;
	buf[bufl - 1] = 0;
	{
		char *s = strstr(buf, "&nbsp;");
		while (s)
		{
			*s = ' ';
			memcpy(s + 1, s + 6, strlen(s + 6) + 1);
			//
			s = strstr(buf, "&nbsp;");
		}
	}
	while (buf[strlen(buf) - 1] == 32)
		buf[strlen(buf) - 1] = 0;
	strcpy(s,buf);
	DEB(if (sv)
		printf("%s\n",buf);)
	if (!*s && !feof(fil))
		return getnext(s, bufl);
	return 2;
}

Readhtml::Readhtml(const Readhtml& ) 
{
}

Readhtml& Readhtml::operator=(const Readhtml& ) 
{ 
	return *this; 
}

} // namespace
