/*
 **	\file Select.cpp
 **	\date  2006-05-05
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "Select.h"


namespace Cgi {


Select::Select(const std::string& name) : Styled(), m_name(name)
{
}


Select::~Select()
{
}


void Select::Add(const std::string& value)
{
	m_values.push_back(new Value(*this, value));
}


void Select::Add(long value,const std::string& description)
{
	m_values.push_back(new Multi(*this, value, description));
}


void Select::Print()
{
	if (GetStyle().size())
	{
		printf("<select style='%s' name='%s'>", GetStyle().c_str(), m_name.c_str());
	}
	else
	{
		printf("<select name='%s'>", m_name.c_str());
	}
	for (std::list<Value *>::iterator it = m_values.begin(); it != m_values.end(); it++)
	{
		Value *p = *it;
		p -> Print();
	}
	printf("</select>");
}


} // namespace
