// WebForm.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _WEBFORM_H
#define _WEBFORM_H

#ifdef _WIN32
#define STL_USING_STRING
#include <stlhelper.h>
#else
#include <string>
#endif

namespace Cgi {

class Web;
class Form;
class Cookies;


//! The CGI forms class

class WebForm
{
public:
  WebForm(Web *,const std::string &);	// Parent, Form unique name
  virtual ~WebForm();

  virtual void Process() = 0;		// FormInput

  virtual void Select(const std::string &) = 0; // <SELECT name=>...</SELECT>
  virtual void List() = 0;		// List
  virtual void Display( long = 0 ) = 0;	// Form

  Form *GetForm();
  Cookies *GetCookies();
  std::string GetCgiName();
  Web *GetWeb();
  
  std::string GetDate();
  std::string GetFormName();
  virtual void nbprintf(char *format, ...);
  virtual void nbfprintf(FILE *,char *format, ...);
  virtual void eprintf(char *format, ...);
  void SetContentType(const std::string&);
  void SetContentDisposition(const std::string&);
  void SetLocation(const std::string&);
  std::string GetRequestMethod();

protected:
  Web *m_pclWeb;
  std::string m_strFormName;

private:
};

} // namespace

#endif // _WEBFORM_H
